#!/bin/sh

#modification history
#--------------------
#01a,07Mar10,kap script now handles all http and https servers intelligently.

# this should be identical to  RMTMGMT_PORT_FILE in rmtMgmtLib.h
RMTGMT_PORT_FILE=/var/rmtMgmtPrt.txt
# poll interval
DELAY_IN_ITER=10

# Remote management server; may be running on custom port
rmtMgmtSupport ()
    {
    if [ -e "$RMTGMT_PORT_FILE" ]; then
        port=`cat $RMTGMT_PORT_FILE`;
        if [ "X" != "X$port" ]; then 
            if [ `netstat -nlt| grep ":$port\b"|wc -l` -ne 1 ]; then
                echo "SHTTPD On Port $port Found Killed"|logger
                echo "Attempting Respawn" | logger
                /work/pfrm1.0/shttpd -d /var/httpd -s /var/shttpd.pem -p $port -D 0 &
                if [ $? -eq 0 ]; then
                    echo "Shttpd Server Respawned On Port $port"|logger
                else
                   echo "Server Failed To Respawn" | logger 
fi
                    # server already running
            fi
        else
           echo "$RMTGMT_PORT_FILE File is Empty" | logger 
        fi
    fi
    }

#supposed to be always running on TCP port 80; LAN HTTP server
lanhttpdSupport()
    {
    if [ `netstat -lnt| awk '{print $4}'|grep "0.0.0.0:80\b" | wc -l` -ne 1 ]; then
        echo "SHTTPD On Port 80 Found Killed"|logger
        echo "Attempting Respawn" | logger
        /work/pfrm1.0/shttpd -d /work/pfrm1.0/cgi-bin/ -D 0 -v 0 & 
        if [ $? -eq 0 ]; then
            echo "Shttpd Server Respawned On Port 80"|logger
        else
           echo "Server Failed To Respawn" | logger 
  fi
   fi
    }

#supposed to be always running on TCP port 443, LAN HTTPS server
lanShttpdSupport()
    {
    if [ `netstat -lnt| awk '{print $4}'|grep "0.0.0.0:443\b" | wc -l` -ne 1 ]; then
        echo "SHTTPD On Port 443 Found Killed"|logger
        echo "Attempting Respawn" | logger
        /work/pfrm1.0/shttpd  -d /work/pfrm1.0/cgi-bin/ -s /var/shttpd.pem -P -D 0 &
        if [ $? -eq 0 ]; then
            echo "Shttpd Server Respawned On Port 443"|logger
        else
           echo "Server Failed To Respawn" | logger 
       fi
   fi
    }

# perpetual
while [ 1 ];
do
    lanhttpdSupport;
    lanShttpdSupport;
    rmtMgmtSupport;
sleep $DELAY_IN_ITER;
done
